searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"Extism.html","title":"Extism","type":"module"},{"doc":"","ref":"Extism.html#set_log_file/2","title":"Extism.set_log_file/2","type":"function"},{"doc":"A CancelHandle is a handle generated by a plugin that allows it to be cancelled from another\nthread while running.","ref":"Extism.CancelHandle.html","title":"Extism.CancelHandle","type":"module"},{"doc":"Cancel plugin execution","ref":"Extism.CancelHandle.html#cancel/1","title":"Extism.CancelHandle.cancel/1","type":"function"},{"doc":"","ref":"Extism.CancelHandle.html#wrap_resource/1","title":"Extism.CancelHandle.wrap_resource/1","type":"function"},{"doc":"This module represents the Native Extism runtime API and is for internal use.\nDo not use or rely on this this module.","ref":"Extism.Native.html","title":"Extism.Native","type":"module"},{"doc":"","ref":"Extism.Native.html#plugin_call/3","title":"Extism.Native.plugin_call/3","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_cancel/1","title":"Extism.Native.plugin_cancel/1","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_cancel_handle/1","title":"Extism.Native.plugin_cancel_handle/1","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_free/1","title":"Extism.Native.plugin_free/1","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_has_function/2","title":"Extism.Native.plugin_has_function/2","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_new_with_manifest/2","title":"Extism.Native.plugin_new_with_manifest/2","type":"function"},{"doc":"","ref":"Extism.Native.html#set_log_file/2","title":"Extism.Native.set_log_file/2","type":"function"},{"doc":"A Plugin represents an instance of your WASM program from the given manifest.","ref":"Extism.Plugin.html","title":"Extism.Plugin","type":"module"},{"doc":"Call a plugin's function by name","ref":"Extism.Plugin.html#call/3","title":"Extism.Plugin.call/3","type":"function"},{"doc":"iex> {:ok, plugin} = Extism.Plugin.new(manifest, false)\n    iex> {:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"this is a test\")\n       # {:ok, \"{\"count\": 4}\"}","ref":"Extism.Plugin.html#call/3-examples","title":"Examples - Extism.Plugin.call/3","type":"function"},{"doc":"- plugin: The plugin\n  - name: The name of the function as a string\n  - input: The input data as a string","ref":"Extism.Plugin.html#call/3-parameters","title":"Parameters - Extism.Plugin.call/3","type":"function"},{"doc":"A string representation of the functions output","ref":"Extism.Plugin.html#call/3-returns","title":"Returns - Extism.Plugin.call/3","type":"function"},{"doc":"Frees the plugin","ref":"Extism.Plugin.html#free/1","title":"Extism.Plugin.free/1","type":"function"},{"doc":"Returns true if the given plugin responds to the given function name","ref":"Extism.Plugin.html#has_function/2","title":"Extism.Plugin.has_function/2","type":"function"},{"doc":"Creates a new plugin","ref":"Extism.Plugin.html#new/2","title":"Extism.Plugin.new/2","type":"function"},{"doc":"- manifest: The manifest as a map https://extism.org/docs/concepts/manifest/\n  - wasi: Use true to enable WASI. Defaults to false.","ref":"Extism.Plugin.html#new/2-parameters","title":"Parameters - Extism.Plugin.new/2","type":"function"},{"doc":"A result tuple with the plugin or an error","ref":"Extism.Plugin.html#new/2-returns","title":"Returns - Extism.Plugin.new/2","type":"function"},{"doc":"","ref":"Extism.Plugin.html#wrap_resource/1","title":"Extism.Plugin.wrap_resource/1","type":"function"},{"doc":"# Extism\n\nExtism Host SDK for Elixir\n\n> *Note*: This houses the 1.0 pre-release version of the Elixir SDK. We may push breaking changes in new versions until will hit 1.0 in December, 2023. But it's currently the best place to start a new integration and we welcome any feedback.","ref":"readme.html","title":"Extism","type":"extras"},{"doc":"Read the [docs on hexdocs.pm](https://hexdocs.pm/extism/).","ref":"readme.html#docs","title":"Docs - Extism","type":"extras"},{"doc":"You can find this package on hex.pm [![hex.pm](https://img.shields.io/hexpm/v/extism.svg)](https://hex.pm/packages/extism)\n\n```elixir\ndef deps do\n  [\n    {:extism, \"1.0.0-rc2\"}\n  ]\nend\n```\n\n> **Note**: You do not need to install the Extism Runtime shared object, but you will need a rust toolchain installed to build this package. See [Install Rust](https://www.rust-lang.org/tools/install) to install for your platform.","ref":"readme.html#installation","title":"Installation - Extism","type":"extras"},{"doc":"This guide should walk you through some of the concepts in Extism and this Elixir library.\n\n> *Note*: You should be able to follow this guide by copy pasting the code into `iex` using `iex -S mix`.\n\n#","ref":"readme.html#getting-started","title":"Getting Started - Extism","type":"extras"},{"doc":"The primary concept in Extism is the [plug-in](https://extism.org/docs/concepts/plug-in). You can think of a plug-in as a code module stored in a `.wasm` file.\n\nSince you may not have an Extism plug-in on hand to test, let's load a demo plug-in from the web:\n\n```elixir\nurl = \"https://github.com/extism/plugins/releases/latest/download/count_vowels.wasm\"\nmanifest = %{wasm: [%{url: url}]}\n{:ok, plugin} = Extism.Plugin.new(manifest, false)\n```\n\n> **Note**: See [the Manifest docs](https://extism.org/docs/concepts/manifest) as it has a rich schema and a lot of options.\n\n#","ref":"readme.html#creating-a-plug-in","title":"Creating A Plug-in - Extism","type":"extras"},{"doc":"This plug-in was written in Rust and it does one thing, it counts vowels in a string. As such, it exposes one \"export\" function: `count_vowels`. We can call exports using [Extism.Plugin#call/3](https://hexdocs.pm/extism/Extism.Plugin.html#call/3):\n\n```elixir\n{:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"Hello, World!\")\n# => {\"count\": 3, \"total\": 3, \"vowels\": \"aeiouAEIOU\"}\n```\n\nAll exports have a simple interface of bytes-in and bytes-out. This plug-in happens to take a string and return a JSON encoded string with a report of results.\n\n#","ref":"readme.html#calling-a-plug-in-s-exports","title":"Calling A Plug-in's Exports - Extism","type":"extras"},{"doc":"Plug-ins may be stateful or stateless. Plug-ins can maintain state b/w calls by the use of variables. Our count vowels plug-in remembers the total number of vowels it's ever counted in the \"total\" key in the result. You can see this by making subsequent calls to the export:\n\n```elixir\n{:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"Hello, World!\")\n# => {\"count\": 3, \"total\": 6, \"vowels\": \"aeiouAEIOU\"}\n{:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"Hello, World!\")\n# => {\"count\": 3, \"total\": 9, \"vowels\": \"aeiouAEIOU\"}\n```\n\nThese variables will persist until this plug-in is freed or you initialize a new one.\n\n#","ref":"readme.html#plug-in-state","title":"Plug-in State - Extism","type":"extras"},{"doc":"> TODO: Implement config\n\nPlug-ins may optionally take a configuration object. This is a static way to configure the plug-in. Our count-vowels plugin takes an optional configuration to change out which characters are considered vowels. Example:\n\n```elixir\n{:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"Yellow, World!\")\n# => {\"count\": 3, \"total\": 3, \"vowels\": \"aeiouAEIOU\"}\n\n{:ok, plugin} = Extism.Plugin.new(manifest, false, %{\"vowels\": \"aeiouyAEIOUY\"})\n{:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"Yellow, World!\")\nplugin.call(\"count_vowels\", \"Yellow, World!\")\n# => {\"count\": 4, \"total\": 4, \"vowels\": \"aeiouAEIOUY\"}\n```\n\n#","ref":"readme.html#configuration","title":"Configuration - Extism","type":"extras"},{"doc":"We don't offer host function support in this library yet. If it is something you need, please [file an issue](https://github.com/extism/elixir-sdk/issues/new)!","ref":"readme.html#host-functions","title":"Host Functions - Extism","type":"extras"}]}